<?php

namespace EnumType;

/**
 * This class stands for statusType EnumType
 * @subpackage Enumerations
 */
class StatusType
{
    /**
     * Constant for value 'NIEPOTWIERDZONA'
     * @return string 'NIEPOTWIERDZONA'
     */
    const VALUE_NIEPOTWIERDZONA = 'NIEPOTWIERDZONA';
    /**
     * Constant for value 'POTWIERDZONA'
     * @return string 'POTWIERDZONA'
     */
    const VALUE_POTWIERDZONA = 'POTWIERDZONA';
    /**
     * Constant for value 'NOWA'
     * @return string 'NOWA'
     */
    const VALUE_NOWA = 'NOWA';
    /**
     * Constant for value 'BRAK'
     * @return string 'BRAK'
     */
    const VALUE_BRAK = 'BRAK';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_NIEPOTWIERDZONA
     * @uses self::VALUE_POTWIERDZONA
     * @uses self::VALUE_NOWA
     * @uses self::VALUE_BRAK
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NIEPOTWIERDZONA,
            self::VALUE_POTWIERDZONA,
            self::VALUE_NOWA,
            self::VALUE_BRAK,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
