<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getKartyResponse StructType
 * @subpackage Structs
 */
class GetKartyResponse extends AbstractStructBase
{
    /**
     * The karta
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\KartaType[]
     */
    public $karta;
    /**
     * Constructor method for getKartyResponse
     * @uses GetKartyResponse::setKarta()
     * @param \StructType\KartaType[] $karta
     */
    public function __construct(array $karta = array())
    {
        $this
            ->setKarta($karta);
    }
    /**
     * Get karta value
     * @return \StructType\KartaType[]
     */
    public function getKarta()
    {
        return $this->karta;
    }
    /**
     * This method is responsible for validating the values passed to the setKarta method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKarta method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKartaForArrayConstraintsFromSetKarta(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getKartyResponseKartaItem) {
            // validation for constraint: itemType
            if (!$getKartyResponseKartaItem instanceof \StructType\KartaType) {
                $invalidValues[] = is_object($getKartyResponseKartaItem) ? get_class($getKartyResponseKartaItem) : sprintf('%s(%s)', gettype($getKartyResponseKartaItem), var_export($getKartyResponseKartaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The karta property can only contain items of type \StructType\KartaType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set karta value
     * @throws \InvalidArgumentException
     * @param \StructType\KartaType[] $karta
     * @return \StructType\GetKartyResponse
     */
    public function setKarta(array $karta = array())
    {
        // validation for constraint: array
        if ('' !== ($kartaArrayErrorMessage = self::validateKartaForArrayConstraintsFromSetKarta($karta))) {
            throw new \InvalidArgumentException($kartaArrayErrorMessage, __LINE__);
        }
        $this->karta = $karta;
        return $this;
    }
    /**
     * Add item to karta value
     * @throws \InvalidArgumentException
     * @param \StructType\KartaType $item
     * @return \StructType\GetKartyResponse
     */
    public function addToKarta(\StructType\KartaType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KartaType) {
            throw new \InvalidArgumentException(sprintf('The karta property can only contain items of type \StructType\KartaType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->karta[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetKartyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
