<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getUbezpieczeniaInfoResponse StructType
 * @subpackage Structs
 */
class GetUbezpieczeniaInfoResponse extends AbstractStructBase
{
    /**
     * The poziomyUbezpieczenia
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UbezpieczeniaInfoType[]
     */
    public $poziomyUbezpieczenia;
    /**
     * Constructor method for getUbezpieczeniaInfoResponse
     * @uses GetUbezpieczeniaInfoResponse::setPoziomyUbezpieczenia()
     * @param \StructType\UbezpieczeniaInfoType[] $poziomyUbezpieczenia
     */
    public function __construct(array $poziomyUbezpieczenia = array())
    {
        $this
            ->setPoziomyUbezpieczenia($poziomyUbezpieczenia);
    }
    /**
     * Get poziomyUbezpieczenia value
     * @return \StructType\UbezpieczeniaInfoType[]|null
     */
    public function getPoziomyUbezpieczenia()
    {
        return $this->poziomyUbezpieczenia;
    }
    /**
     * This method is responsible for validating the values passed to the setPoziomyUbezpieczenia method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPoziomyUbezpieczenia method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePoziomyUbezpieczeniaForArrayConstraintsFromSetPoziomyUbezpieczenia(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem) {
            // validation for constraint: itemType
            if (!$getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem instanceof \StructType\UbezpieczeniaInfoType) {
                $invalidValues[] = is_object($getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem) ? get_class($getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem) : sprintf('%s(%s)', gettype($getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem), var_export($getUbezpieczeniaInfoResponsePoziomyUbezpieczeniaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The poziomyUbezpieczenia property can only contain items of type \StructType\UbezpieczeniaInfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set poziomyUbezpieczenia value
     * @throws \InvalidArgumentException
     * @param \StructType\UbezpieczeniaInfoType[] $poziomyUbezpieczenia
     * @return \StructType\GetUbezpieczeniaInfoResponse
     */
    public function setPoziomyUbezpieczenia(array $poziomyUbezpieczenia = array())
    {
        // validation for constraint: array
        if ('' !== ($poziomyUbezpieczeniaArrayErrorMessage = self::validatePoziomyUbezpieczeniaForArrayConstraintsFromSetPoziomyUbezpieczenia($poziomyUbezpieczenia))) {
            throw new \InvalidArgumentException($poziomyUbezpieczeniaArrayErrorMessage, __LINE__);
        }
        $this->poziomyUbezpieczenia = $poziomyUbezpieczenia;
        return $this;
    }
    /**
     * Add item to poziomyUbezpieczenia value
     * @throws \InvalidArgumentException
     * @param \StructType\UbezpieczeniaInfoType $item
     * @return \StructType\GetUbezpieczeniaInfoResponse
     */
    public function addToPoziomyUbezpieczenia(\StructType\UbezpieczeniaInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UbezpieczeniaInfoType) {
            throw new \InvalidArgumentException(sprintf('The poziomyUbezpieczenia property can only contain items of type \StructType\UbezpieczeniaInfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->poziomyUbezpieczenia[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUbezpieczeniaInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
