<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for potwierdzenieOdbioruKurierskaType StructType
 * @subpackage Structs
 */
class PotwierdzenieOdbioruKurierskaType extends AbstractStructBase
{
    /**
     * The ilosc
     * Meta information extracted from the WSDL
     * - base: xsd:int
     * - maxInclusive: 9
     * - minInclusive: 0
     * @var int
     */
    public $ilosc;
    /**
     * The sposob
     * @var string
     */
    public $sposob;
    /**
     * Constructor method for potwierdzenieOdbioruKurierskaType
     * @uses PotwierdzenieOdbioruKurierskaType::setIlosc()
     * @uses PotwierdzenieOdbioruKurierskaType::setSposob()
     * @param int $ilosc
     * @param string $sposob
     */
    public function __construct($ilosc = null, $sposob = null)
    {
        $this
            ->setIlosc($ilosc)
            ->setSposob($sposob);
    }
    /**
     * Get ilosc value
     * @return int|null
     */
    public function getIlosc()
    {
        return $this->ilosc;
    }
    /**
     * Set ilosc value
     * @param int $ilosc
     * @return \StructType\PotwierdzenieOdbioruKurierskaType
     */
    public function setIlosc($ilosc = null)
    {
        // validation for constraint: int
        if (!is_null($ilosc) && !(is_int($ilosc) || ctype_digit($ilosc))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ilosc, true), gettype($ilosc)), __LINE__);
        }
        // validation for constraint: maxInclusive(9)
        if (!is_null($ilosc) && $ilosc > 9) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically less than or equal to 9', var_export($ilosc, true)), __LINE__);
        }
        // validation for constraint: minInclusive
        if (!is_null($ilosc) && $ilosc < 0) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically greater than or equal to 0', var_export($ilosc, true)), __LINE__);
        }
        $this->ilosc = $ilosc;
        return $this;
    }
    /**
     * Get sposob value
     * @return string|null
     */
    public function getSposob()
    {
        return $this->sposob;
    }
    /**
     * Set sposob value
     * @uses \EnumType\SposobPrzekazaniaPotwierdzeniaOdbioruKurierskaType::valueIsValid()
     * @uses \EnumType\SposobPrzekazaniaPotwierdzeniaOdbioruKurierskaType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sposob
     * @return \StructType\PotwierdzenieOdbioruKurierskaType
     */
    public function setSposob($sposob = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SposobPrzekazaniaPotwierdzeniaOdbioruKurierskaType::valueIsValid($sposob)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\SposobPrzekazaniaPotwierdzeniaOdbioruKurierskaType', is_array($sposob) ? implode(', ', $sposob) : var_export($sposob, true), implode(', ', \EnumType\SposobPrzekazaniaPotwierdzeniaOdbioruKurierskaType::getValidValues())), __LINE__);
        }
        $this->sposob = $sposob;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PotwierdzenieOdbioruKurierskaType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
