<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for profilType StructType
 * @subpackage Structs
 */
class ProfilType extends AdresType
{
    /**
     * The idProfil
     * @var int
     */
    public $idProfil;
    /**
     * The nazwaSkrocona
     * @var string
     */
    public $nazwaSkrocona;
    /**
     * The fax
     * @var string
     */
    public $fax;
    /**
     * Constructor method for profilType
     * @uses ProfilType::setIdProfil()
     * @uses ProfilType::setNazwaSkrocona()
     * @uses ProfilType::setFax()
     * @param int $idProfil
     * @param string $nazwaSkrocona
     * @param string $fax
     */
    public function __construct($idProfil = null, $nazwaSkrocona = null, $fax = null)
    {
        $this
            ->setIdProfil($idProfil)
            ->setNazwaSkrocona($nazwaSkrocona)
            ->setFax($fax);
    }
    /**
     * Get idProfil value
     * @return int|null
     */
    public function getIdProfil()
    {
        return $this->idProfil;
    }
    /**
     * Set idProfil value
     * @param int $idProfil
     * @return \StructType\ProfilType
     */
    public function setIdProfil($idProfil = null)
    {
        // validation for constraint: int
        if (!is_null($idProfil) && !(is_int($idProfil) || ctype_digit($idProfil))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idProfil, true), gettype($idProfil)), __LINE__);
        }
        $this->idProfil = $idProfil;
        return $this;
    }
    /**
     * Get nazwaSkrocona value
     * @return string|null
     */
    public function getNazwaSkrocona()
    {
        return $this->nazwaSkrocona;
    }
    /**
     * Set nazwaSkrocona value
     * @param string $nazwaSkrocona
     * @return \StructType\ProfilType
     */
    public function setNazwaSkrocona($nazwaSkrocona = null)
    {
        // validation for constraint: string
        if (!is_null($nazwaSkrocona) && !is_string($nazwaSkrocona)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nazwaSkrocona, true), gettype($nazwaSkrocona)), __LINE__);
        }
        $this->nazwaSkrocona = $nazwaSkrocona;
        return $this;
    }
    /**
     * Get fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->fax;
    }
    /**
     * Set fax value
     * @param string $fax
     * @return \StructType\ProfilType
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->fax = $fax;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProfilType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
