<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateEnvelopeBufor StructType
 * @subpackage Structs
 */
class UpdateEnvelopeBufor extends AbstractStructBase
{
    /**
     * The bufor
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\BuforType[]
     */
    public $bufor;
    /**
     * Constructor method for updateEnvelopeBufor
     * @uses UpdateEnvelopeBufor::setBufor()
     * @param \StructType\BuforType[] $bufor
     */
    public function __construct(array $bufor = array())
    {
        $this
            ->setBufor($bufor);
    }
    /**
     * Get bufor value
     * @return \StructType\BuforType[]
     */
    public function getBufor()
    {
        return $this->bufor;
    }
    /**
     * This method is responsible for validating the values passed to the setBufor method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBufor method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBuforForArrayConstraintsFromSetBufor(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateEnvelopeBuforBuforItem) {
            // validation for constraint: itemType
            if (!$updateEnvelopeBuforBuforItem instanceof \StructType\BuforType) {
                $invalidValues[] = is_object($updateEnvelopeBuforBuforItem) ? get_class($updateEnvelopeBuforBuforItem) : sprintf('%s(%s)', gettype($updateEnvelopeBuforBuforItem), var_export($updateEnvelopeBuforBuforItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bufor property can only contain items of type \StructType\BuforType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bufor value
     * @throws \InvalidArgumentException
     * @param \StructType\BuforType[] $bufor
     * @return \StructType\UpdateEnvelopeBufor
     */
    public function setBufor(array $bufor = array())
    {
        // validation for constraint: array
        if ('' !== ($buforArrayErrorMessage = self::validateBuforForArrayConstraintsFromSetBufor($bufor))) {
            throw new \InvalidArgumentException($buforArrayErrorMessage, __LINE__);
        }
        $this->bufor = $bufor;
        return $this;
    }
    /**
     * Add item to bufor value
     * @throws \InvalidArgumentException
     * @param \StructType\BuforType $item
     * @return \StructType\UpdateEnvelopeBufor
     */
    public function addToBufor(\StructType\BuforType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BuforType) {
            throw new \InvalidArgumentException(sprintf('The bufor property can only contain items of type \StructType\BuforType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bufor[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateEnvelopeBufor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
